
#include "common.h"
#include <string.h>
#include "MyStack.h"

/*	 ǥ ϴ Լ	*/
float Calculate(const char* postfix);

int main(void)
{
	/*	 ǥ ((1-2)+3)*(5-2)  ǥ Ʒ .	*/
	char* Postfix = "12-3+52-*";
	float result = Calculate(Postfix);

	printf("  : %.2f\n", result);

	return 0;
}

/*	 ǥ ϴ Լ	*/
float Calculate(const char* postfix)
{
	MyStack s;
	
	int len = strlen(postfix);
	float result = 0.0;
	float num1 = 0.0, num2 = 0.0;
	int i;

	MyStackInit(&s);	//	 ʱȭ

	for ( i = 0; i < len; i++)
	{
		/*	̸	*/
		if (postfix[i] == '*' || postfix[i] == '/' ||
			postfix[i] == '+' || postfix[i] == '-')
		{
			num1 = Top(&s);
			Pop(&s);

			num2 = Top(&s);
			Pop(&s);
		}

		switch (postfix[i])
		{
			case '*':	Push(&s, num2 * num1);	break;
			case '/':	Push(&s, num2 / num1);	break;
			case '+':	Push(&s, num2 + num1);	break;
			case '-':	Push(&s, num2 - num1);	break;
			default:
			{
				//	 ̸ ÿ .
				//	'1' - '0' = 1 ̴.
				Push(&s, (float)(postfix[i] - '0'));
				break;
			}
		}
	}
	result = Top(&s);
	Pop(&s);

	return result;
}